%global debug_package   %{nil}
%global provider        github
%global provider_tld    com
%global project         go-mgo
%global repo            mgo
# https://github.com/go-mgo/mgo
%global import_path     %{provider}.%{provider_tld}/%{project}/%{repo}
%global commit          r2015.01.24
%global shortcommit     %(c=%{commit}; echo ${c:0:7})
%global import_path_sec gopkg.in/mgo.v2

Name:           golang-%{provider}-%{project}-%{repo}
Version:        %{commit}
Release:        1%{?dist}
Summary:        The MongoDB driver for Go
License:        BSD
URL:            https://%{import_path}
Source0:        https://%{import_path}/archive/%{commit}/%{repo}-%{shortcommit}.tar.gz
%if 0%{?fedora} >= 19 || 0%{?rhel} >= 7
BuildArch:      noarch
%else
ExclusiveArch:  %{ix86} x86_64 %{arm}
%endif

%description
%{summary}

%package devel
BuildRequires:  golang >= 1.2.1-3
BuildRequires:  golang(gopkg.in/check.v1)
#BuildRequires:  golang(gopkg.in/mgo.v2/bson)
#BuildRequires:  golang(gopkg.in/mgo.v2/internal/scram)
#BuildRequires:  golang(gopkg.in/mgo.v2)
#BuildRequires:  golang(gopkg.in/mgo.v2/sasl)
#BuildRequires:  golang(gopkg.in/mgo.v2/txn)
Requires:       golang >= 1.2.1-3
Requires:       golang(gopkg.in/check.v1)
#Requires:       golang(gopkg.in/mgo.v2/bson)
#Requires:       golang(gopkg.in/mgo.v2/internal/scram)
#Requires:       golang(gopkg.in/mgo.v2)
#Requires:       golang(gopkg.in/mgo.v2/sasl)
#Requires:       golang(gopkg.in/mgo.v2/txn)
Summary:        %{summary}
Provides:       golang(%{import_path}) = %{version}-%{release}
Provides:       golang(%{import_path}/bson) = %{version}-%{release}
Provides:       golang(%{import_path}/internal/scram) = %{version}-%{release}
Provides:       golang(%{import_path}/sasl) = %{version}-%{release}
Provides:       golang(%{import_path}/txn) = %{version}-%{release}
Provides:       golang(%{import_path_sec}) = %{version}-%{release}
Provides:       golang(%{import_path_sec}/bson) = %{version}-%{release}
Provides:       golang(%{import_path_sec}/internal/scram) = %{version}-%{release}
Provides:       golang(%{import_path_sec}/sasl) = %{version}-%{release}
Provides:       golang(%{import_path_sec}/txn) = %{version}-%{release}

%description devel
%{summary}

This package contains library source intended for 
building other packages which use %{project}/%{repo}.

%prep
%setup -q -n %{repo}-%{commit}

%build

%install
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
cp -pav *.go %{buildroot}/%{gopath}/src/%{import_path}/
cp -rpav bson %{buildroot}/%{gopath}/src/%{import_path}/
cp -rpav internal %{buildroot}/%{gopath}/src/%{import_path}/
cp -rpav sasl %{buildroot}/%{gopath}/src/%{import_path}/
cp -rpav testdb %{buildroot}/%{gopath}/src/%{import_path}/
cp -rpav txn %{buildroot}/%{gopath}/src/%{import_path}/
install -d -p %{buildroot}/%{gopath}/src/%{import_path_sec}/
cp -pav *.go %{buildroot}/%{gopath}/src/%{import_path_sec}/
cp -rpav bson %{buildroot}/%{gopath}/src/%{import_path_sec}/
cp -rpav internal %{buildroot}/%{gopath}/src/%{import_path_sec}/
cp -rpav sasl %{buildroot}/%{gopath}/src/%{import_path_sec}/
cp -rpav testdb %{buildroot}/%{gopath}/src/%{import_path_sec}/
cp -rpav txn %{buildroot}/%{gopath}/src/%{import_path_sec}/

%check
# Disabled due to broken mongodb in rawhide
# GOPATH=%{buildroot}/%{gopath}:%{gopath} go test %{import_path_sec}
GOPATH=%{buildroot}/%{gopath}:%{gopath} go test %{import_path_sec}/bson
GOPATH=%{buildroot}/%{gopath}:%{gopath} go test %{import_path_sec}/internal/scram
# Disabled due to broken mongodb in rawhide
# GOPATH=%{buildroot}/%{gopath}:%{gopath} go test %{import_path_sec}/txn

%files devel
%doc README.md LICENSE
%dir %{gopath}/src/%{provider}.%{provider_tld}/%{project}
%{gopath}/src/%{import_path}
%{gopath}/src/%{import_path_sec}

%changelog
* Sun Apr 19 2015 Graeme Gillies <ggillies@redhat.com> - 0-0.1.gitr2015.0
- First package for Fedora


